without trace
without warning
include machine.e

----------------------------------------------------------------------------
----------------------------------------------------------------------------
-- FILE I/O
--/topic File I/O
--/info
-- File Utility Routines

--/topic File I/O
--/func readBytes( integer hFile, integer size )
--/desc Reads in /i size bytes of data from the /i hFile handle.
--/ret Sequence: The bytes read in.
--
--Example
--/code
--    sequence Buffer
--    Buffer =
----------------------------------------------------------------------------
global function xreadBytes( integer hFile, integer size )

    -- read bytes from file

    sequence s

    s = repeat( 0, size )    
    for i = 1 to size do   
        s[i] = getc( hFile )
    end for
    return s
    
end function


----------------------------------------------------------------------------
global function readLong( integer hFile )

    -- read a Long from the file

    return bytes_to_int( get_bytes( hFile, 4 ) )
    
end function

----------------------------------------------------------------------------
global function readWord( integer hFile )

    -- read a Word from the file

    return bytes_to_int( get_bytes( hFile, 2 ) & {0, 0} )
    
end function



----------------------------------------------------------------------------
global function loadStructFromFile( integer hFile, atom into, integer bytes)

    -- load structure on file directly into a memory structure
    sequence s

    -- the sequence will hold the data temporarily
    s = get_bytes(hFile, bytes)
    -- look for a EOF
    if length( s ) < bytes then
        -- end of file, return failure
        return 0
    end if       

    -- load structure    
    poke( into, s )
    
    -- return success
    return 1

end function


----------------------------------------------------------------------------
global procedure storeStructToFile( integer hFile, atom struct, integer bytes)

    puts(hFile, peek({struct, bytes}) )

end procedure




